Switch to better reporting mechanism

11/03/2017 01:34 AM - Luke Murphey

Status: Closed Start date: 11/02/2017

Priority: Normal Due date:  

Assignee:  % Done: 100%

Category:  Estimated time: 0.00 hour

Target version:    

Description

History

#1 - 11/03/2017 01:35 AM - Luke Murphey

HtmlTestRunner: https://github.com/oldani/HtmlTestRunner/releases: 1.1.1

Jinja: https://github.com/pallets/jinja/releases: 2.9.6

MarkupSafe: https://pypi.python.org/pypi/MarkupSafe: 1.0.0

#2 - 11/03/2017 01:44 AM - Luke Murphey

How to use the report files:

https://docs.gocd.org/current/configuration/managing_artifacts_and_reports.html

https://docs.gocd.org/current/configuration/dev_upload_test_report.html

#3 - 11/03/2017 02:19 AM - Luke Murphey

HtmlTestRunner doesn't allow you to set a static file name.

Here is what I am considering:

Setting outsuffix so that the file doesn't have the time markers

This causes the file to not even have an ending

The file name will still change depending on the test name which means GoCD cannot pull it in

Renaming the file when done

This doesn't work since the test runner calls exit()

The system creates multiple HTML files (one for each class)

See https://github.com/oldani/HtmlTestRunner/issues/6

#4 - 11/03/2017 02:57 AM - Luke Murphey

See also http://tungwaiyip.info/software/HTMLTestRunner.html

Isn't capable of running the entire test suite without declaring the entire test suite

Apparently doesn't run all tests from a suite via a list from loader.loadTestsFromTestCase()

Doesn't allow running individual tests via CLI options
#5 - 11/03/2017 05:18 AM - Luke Murphey

- Project changed from Webhooks Input to Splunk Apps

#6 - 11/03/2017 05:06 PM - Luke Murphey

splunk-app-unit-tests-6.2-plus

[Done] webhooks-input

[Done] web-input

[Done] ftp-receiver

[Done] syndication-input

[Done] network-tools

splunk-app-unit-tests-6.3-plus

[Done] website-monitoring

splunk-app-unit-tests-6.0-plus

[Done] file-info

splunk-app-unit-tests-6.4-plus

[Done] lookup-editor

#7 - 11/03/2017 09:01 PM - Luke Murphey

Here is another one: https://github.com/lucrib/HTMLTestRunner2

#8 - 11/04/2017 06:18 AM - Luke Murphey

I don't think it is logging skipped tests.

#9 - 11/04/2017 07:07 AM - Luke Murphey

For future reference, here is how I am upgrading the tests:

Add the following imports:

import errno

import HTMLTestRunner

 

Make sure to put the HTMLTestRunner class next to unit.py.

Then add the test code:

if __name__ == '__main__':

    report_path = os.path.join('..', os.environ.get('TEST_OUTPUT', 'tmp/test_report.html'))

    # Make the test directory

    try:

        os.makedirs(os.path.dirname(report_path))

    except OSError as exception:

        if exception.errno != errno.EEXIST:

            raise

    with open(report_path, 'w') as report_file:

        test_runner = HTMLTestRunner.HTMLTestRunner(

            stream=report_file

        )

        unittest.main(testRunner=test_runner)
#10 - 11/04/2017 07:30 AM - Luke Murphey

- % Done changed from 0 to 80

#11 - 11/04/2017 06:02 PM - Luke Murphey

- Status changed from New to Closed

- % Done changed from 80 to 100
